%define name		argouml
%define Name		ArgoUML
%define Summary		The Cognitive CASE Tool
%define version		0.13.3
%define release		1jpp
%define appdir		%{_datadir}/%{name}
%define javadir		%{_datadir}/java
%define javadocdir	%{_datadir}/javadoc
%define section		free
%define gef_version	0.9.6

# These are needed in order to build successfully on non-Mandrake systems.
%{!?_menudir:           %define _menudir   %{_libdir}/menu}
%{!?_miconsdir:         %define _miconsdir %{_datadir}/icons/mini}
%{!?_iconsdir:          %define _iconsdir  %{_datadir}/icons}
%{!?_liconsdir:         %define _liconsdir %{_datadir}/icons/large}

Name:           %{name}
Version:        %{version}
Release:        %{release}
Summary:        %{Summary}
License:        BSD
URL:            http://argouml.tigris.org
Group:		Development
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	%{Name}-%{version}-src.tar.gz
Source1:        %{name}.argouml.script.bz2
Source2:	%{name}.icon-16.png.bz2
Source3:	%{name}.icon-32.png.bz2
Source4:	%{name}.icon-48.png.bz2
Patch0:		%{name}.build.patch.bz2
Requires:       jpackage-utils
Requires:       jaxp_parser_impl
Requires:       dresden-ocl-argo
Requires:       nsuml
Requires:       gef >= %{gef_version}
Requires:       antlr
Requires:       saxon
Requires:       jdepend
BuildRequires:  ant >= 1.4.1-9jpp
BuildRequires:  junit
BuildRequires:  antlr
BuildRequires:  dresden-ocl-argo
BuildRequires:  nsuml
BuildRequires:  gef >= %{gef_version}
BuildRequires:  log4j
BuildRequires:  saxon
BuildRequires:  jdepend
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
The goal of the ArgoUML project is to build an object oriented design
tool that is:
- A joy to use (we really mean it),
- Actually helpful to designers when they are making design decisions,
- Completely open source Java,
- Leading edge (supports the latest UML specifications),
- Modular and extensible,
- Integrated with the web and other Tigris tools.

%package mdkmenu
Summary:	Mandrake menu entry for %{name}
Group:		Development
Requires:	%{name} = %{version}-%{release}

%description mdkmenu
This is a Mandrake menu system entry for %{name}.

%package rhmenu
Summary:	Red Hat menu entry for %{name}
Group:		Development
Requires:	%{name} = %{version}-%{release}

%description rhmenu
This is a Red Hat menu system entry for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -c -n %{name}
%patch0

bzcat %{SOURCE1} > %{name}
bzcat %{SOURCE2} > %{name}-16.png
bzcat %{SOURCE3} > %{name}-32.png
bzcat %{SOURCE4} > %{name}-48.png
# remove binary files
find . -name "*.jar" -exec rm -f {} \;
# clean manifest files
for file in `find . -type f -name *.mf`; do perl -pi -e 's/^.*\.jar.*$//s' $file; done

%build
export CLASSPATH=\
%{javadir}/dresden-ocl-argo.jar:\
%{javadir}/nsuml.jar:\
%{javadir}/gef.jar:\
%{javadir}/log4j.jar:\
%{javadir}/antlr.jar:\
%{javadir}/junit.jar:\
%{javadir}/saxon.jar:\
%{javadir}/jdepend.jar
cd src_new
ant -buildfile build.xml -Dbuild.compiler=modern jar
ant -buildfile build.xml -Dbuild.compiler=modern prepare-docs
cd ..

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{appdir}/lib
install -m 644 build/%{name}.jar $RPM_BUILD_ROOT%{appdir}/lib
# scripts
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 %{name} $RPM_BUILD_ROOT%{_bindir}/%{name}
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
# mdk menu entry
install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Development/Development environments"\\
title="%{Name}" \
longtitle="%{Summary}"
EOF
# mdk icons
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png 
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png 
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png
# rh menu entry
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development
cat >$RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development/%{name}.desktop <<EOF
[Desktop Entry]
Name=%{Name}
Comment=%{Summary}
Exec=%{_bindir}/%{name}
Terminal=0
Type=Application
Icon=%{name}.png
EOF
# icons for rh menu
install -D -m 644 %{name}-16.png \
    $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -m 644 %{name}-32.png \
    $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -m 644 %{name}-48.png \
    $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png


%clean
rm -rf $RPM_BUILD_ROOT

%post
cd %{appdir}/lib \
&& ln -sf %{javadir}/dresden-ocl-argo.jar \
&& ln -sf %{javadir}/nsuml.jar \
&& ln -sf %{javadir}/gef.jar \
&& ln -sf %{javadir}/log4j.jar \
&& ln -sf %{javadir}/antlr.jar \
&& ln -sf %{javadir}/xml-commons-apis.jar \
&& ln -sf %{javadir}/jaxp_parser_impl.jar
 
%postun
# remove links only if uninstalling
if [ $1 = 0 ]; then
	cd %{appdir}/lib \
	&& rm -f dresden-ocl-argo.jar \
	&& rm -f nsuml.jar \
	&& rm -f gef.jar \
	&& rm -f log4j.jar \
	&& rm -f antlr.jar \
	&& rm -f xml-commons-apis.jar \
	&& rm -f jaxp_parser_impl.jar \
	&& rm -f saxon.jar \
	&& rm -f jdepend.jar
fi

%post mdkmenu
%update_menus
 
%postun mdkmenu
%clean_menus

%files
%defattr(-,root,root)
%doc src_new/README_COMPILE.txt src_new/README_database.sql src_new/README.txt
%{_bindir}/*
%{appdir}

%files mdkmenu
%defattr(-,root,root)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files rhmenu
%defattr(-,root,root,-)
%{_sysconfdir}/X11/applnk/Development/*
%{_datadir}/icons/*/*/apps/*

%files javadoc
%defattr(-,root,root)
%{javadocdir}/%{name}-%{version}

%changelog
* Thu Mar 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.3-1jpp
- 0.13.3

* Thu Feb 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.2-1jpp
- 0.13.2 
- log4j patch merged upstream

* Mon Dec 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.13.1-1jpp
- 0.13.1
- regenerated patches

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-3jpp
- revert back to requiring gef >= 0.9.6

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-2jpp
- add %%gef_version macro
- require latest gef rpm
- change 'ln -s' to 'ln -sf'

* Fri Oct 17 2002 David Walluck <david@anti-microsoft.org> 0.12-1jpp
- 0.12
- bzip2 sources
- require jdepend (may not be needed now, but needed for CVS versions)
- rediff build patch

* Mon Oct 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.11.4-1jpp
- update from David Walluck <david@anti-microsoft.org>
 - 0.11.4
 - experimental log4j patch
- only remove symlinks if uninstalling, not upgrading

* Sun Sep  8 2002 Ville Skytt <ville.skytta at iki.fi> 0.10.1-2jpp
- Add Red Hat menu item.
- Menu packages require main package.
- Fix menu entries' descriptions.
- Changed License to BSD.
- Use full URL to source tarball.

* Fri Sep 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.10.1-1jpp
- 0.10.1 
- new application policy

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-2jpp 
- hardcoded distribution and vendor tag
- group tag again

* Mon May 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-1jpp
- 0.9.9
- source system prefs in launch script
- inactivated jikes building

* Thu May 2 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-2jpp 
- distribution tag
- group tag
- source user prefs before configuration in launch script

* Tue Apr 09 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-1jpp
- 0.9.8

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.7-1jpp
- 0.9.7
- patch merged upstream

* Mon Mar 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-2jpp
- requires jaxp_parser2 instead of xerces-j1
- buildrequires ant >= 1.4.1-9jpp
- applied npe-fix.patch
- dropped xerces-j2 workaround

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-1jpp
- 0.9.6
- used png for icons
- section macro
- requires gef >= 0.9.6
- no more version dependecy on dresden-ocl
- no more dependency on log4j as gef already depends on it
- fixed missing macros for mdkmenu package

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-3jpp
- merged mdk and jpp branches
- additional sources in individual archives

* Fri Jan 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-2jpp
- requires antlr
- requires xerces-j1 instead of jaxp_parser (doesn't work with crimson)
- requires gef >= 0.9.5-5jpp as parasite class-path reference in manifest make crimson loading first
- corrected launch script
- javadoc in %{_datadir}/javadoc

* Tue Jan 8 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-1jpp
- 0.9.5
- requires log4j
- buildrequires log4j, junit and antlr
- javadoc package

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-8jpp
- Requires jpackage-utils

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-7jpp
- new launch script using functions library

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-6jpp
- used original tarball
- build patch for ant 1.4
- recreated source patch

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-5jpp
- more macros

* Fri Sep 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-4jpp
- first unified JPackage release
- GEF is now gef
- only dresden-ocl-argo is required
- unified launch script
- no more classpath in manifest
- s/jPackage/JPackage

* Thu Sep 13 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-3mdk
- menu entry
- used lower case for name
- spec cleanup

* Sat Jul 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-2mdk
- requires jaxp_parser
- use jaxp_parser alternative

* Sat Jun 23 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-1mdk
- first Mandrake release
